import java.io.*;
import java.util.*;

/*
Si consideri la definizione di coppia in Pair.Java, per coppie non modificabili.
Si chiede di:
 (a) Ridefinirla in un un ADT, MUPairADT.java, per coppie modificabili e componenti non nulli;
 (b) Fornire AF e I  di (della rappresentazione data in) MUPairADT.java;
 (c) Fornire un caso di uso di MUPairADT.java;
 (d) Provare la correttezza di I.

 public class Pair <A,B> {
   public final A left;
   public final B right;
   public Pair (A x, B y) {
      left = x;
      right = y;
   }
}
 */

/* (a) */
class invalidArgException extends Exception{
}

class MuPairADT <A,B> {
    private A left;//da nascondere
    private B right;//da nascondere
    public MuPairADT (A x, B y) throws invalidArgException{
        if(x==null || y==null) throw new invalidArgException();
        left = x;
        right = y;
    }
    public A getLeft(){//da aggiungere per uso effettivo
        return left;
    }
    public B getRight(){//da aggiungere per uso effettivo
        return right;
    }
    public void setLeft(A x){//da aggiungere per uso effettivo
                             //c'è un errore
        left = x;
    }
    public void setRight(B y){//da aggiungere per uso effettivo
                              //c'è un errore
        right = y;
    }

}

/* (b) 
Sia [ImPairADT<Ta,Tb>]={(x,y) | x\inTa, y\inTb, Ta\in[A], Tb\in[B]}, l'insieme dei valori
astratti definiti da ImPairADT<Ta,Tb>. Allora, per ogni valore concreto c esprimibile con
lo stato concreto definito dai fields della classe:
AF(c) = (c.left,c.right)
I(c) = c.left!=null & c.right!=null
*/

/* (c) */
class main{
    public static void main(String args[]) throws invalidArgException{
        MuPairADT <String,Integer> myAddress = new MuPairADT<String,Integer>("Pontecorvo",4);
        System.out.println("l'indirizzo è via " + myAddress.getLeft() + ", " + myAddress.getRight());
        myAddress.setRight(12);
        System.out.println("l'indirizzo è cambiato in " + myAddress.getLeft() + ", " + myAddress.getRight());
        
    }
}

/* (d)
 Dobbiamo provare che I(c)= c.left!=null & c.right!=null è sempre verificato dallo stato 
 di un valore astratto di tipo MuPairADT.
 Fatto1: Costruttori. Il primo stm controlla che il valore (x,y) è costruito solo se x!=null!=y.
 Fatto2: Modificatori non soddisfano I(c)
 */
